package kr.go.busan.bsopenapp;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.webkit.WebBackForwardList;
import android.webkit.WebChromeClient;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.ImageView;
import android.widget.Toast;

public class MainActivity extends Activity {
	public static MainActivity main = null;
	public WebView web = null;
	public SharedPreferences mPreferences;
	private static final String TAG = "MainActivity";

	private Boolean bFinish = false;

	@SuppressWarnings("deprecation")
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

//		startActivity(new Intent(this, SplashActivity.class));
		setContentView(R.layout.activity_main);

		mPreferences = getSharedPreferences("CurrentUser", MODE_PRIVATE); // public으로
																			// 하면
																			// 외부
																			// 접근
																			// 가능

		main = this;

		// 객체 생성 및 초기화, 사이즈 변경
		init();

		// 웹 로드
		webLoad();

	}

	private void init() {
		// 웹뷰
		web = (WebView) findViewById(R.id.WebView);
		
		ImageView btnHome = (ImageView)this.findViewById(R.id.btnHome);
		btnHome.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				web.loadUrl(Info.getURL(0));
			}
		});
		
		ImageView btnPrev = (ImageView)this.findViewById(R.id.btnPrev);
		btnPrev.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				if(web.canGoBack())
					web.goBack();
			}
		});
		
		ImageView btnNext = (ImageView)this.findViewById(R.id.btnNext);
		btnNext.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				if(web.canGoForward())
					web.goForward();
			}
		});
		
		ImageView btnRefresh = (ImageView)this.findViewById(R.id.btnRefresh);
		btnRefresh.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				web.reload();
			}
		});
		
	}

	@SuppressLint("SetJavaScriptEnabled")
	private void webLoad() {
		String url = this.getIntent().getDataString();
		if (url == null || url.trim().equals("")) {
			url = Info.getURL(0);
		}

		web.getSettings().setJavaScriptEnabled(true);
		web.getSettings().setAllowFileAccess(true);
		web.getSettings().setAllowUniversalAccessFromFileURLs(true);
		web.getSettings().setAllowContentAccess(true);
		web.getSettings().setAllowFileAccessFromFileURLs(true);
		web.getSettings().setSupportZoom(true);
		web.getSettings().setBuiltInZoomControls(true);
		web.clearCache(true);
		web.clearHistory();
		web.clearFormData();
		web.setWebViewClient(new MyWebViewClient());

		web.setWebChromeClient(new MyWebChromeClient());

		web.loadUrl(url);
		
		Map<String, String> extraHeaders = new HashMap<String, String>();
		  extraHeaders.put("ACCEPT", "text/html");
		  web.loadUrl(url, extraHeaders);
		//web.loadUrl()
	}

	final class MyWebChromeClient extends WebChromeClient {
		public boolean onJsAlert(WebView view, String url, String message,
				final android.webkit.JsResult result) {
			// result.confirm();
			// return true;

			// 웹뷰에 얼럿창 띄움
			new AlertDialog.Builder(MainActivity.this)
					.setTitle("알림")
					.setMessage(message)
					.setPositiveButton(android.R.string.ok,
							new AlertDialog.OnClickListener() {
								public void onClick(DialogInterface dialog,
										int which) {
									result.confirm();
								}
							}).setCancelable(false).create().show();

			Log.i("Message", message);
			return true;
		}
	}

	private class MyWebViewClient extends WebViewClient {
		@SuppressLint("DefaultLocale")
		@Override
		public boolean shouldOverrideUrlLoading(WebView view, String url) {
			// Log.i("URL", url);
			if (url.endsWith(".mp4")) {

			}
			else if (url.matches("market://.*")) {
				Intent intent = new Intent(Intent.ACTION_VIEW);
				intent.setData(Uri.parse(url));
				startActivity(intent);

			} else if (url.matches("http://play.google.com/store/apps/.*")) {
				Intent intent = new Intent(Intent.ACTION_VIEW);
				intent.setData(Uri.parse(url));
				startActivity(intent);

			} else if (url.contains("tel:")) {
				Intent intent = new Intent(Intent.ACTION_VIEW);
				intent.setData(Uri.parse(url));
				startActivity(intent);
			} else {
				view.loadUrl(url);
			}
			return true;
		}

		ProgressDialog progressDialog = new ProgressDialog(MainActivity.this);

		@Override
		public void onPageFinished(WebView view, String url) {
			super.onPageFinished(view, url);
			progressDialog.hide();
			if (!web.canGoBack())
				progressDialog.dismiss();
			Log.i("URL", "Finished : " + url);
		}

		@Override
		public void onPageStarted(WebView view, String url, Bitmap favicon) {
			super.onPageStarted(view, url, favicon);
			progressDialog.setMessage("Searching.");
			progressDialog.setIndeterminate(true);
			progressDialog.show();
		}
	}

	@SuppressLint("HandlerLeak")
	@Override
	public void onBackPressed() {
		WebBackForwardList list = web.copyBackForwardList();
		String url = web.getUrl();

		if (url.contains(Info.getURL(0)) || url.contains(Info.getURL(1))) {
			super.onBackPressed(); // 없으면 종료
		} else if (url.contains(Info.getURL(2)) || url.contains(Info.getURL(3))
				|| url.contains(Info.getURL(4))) {
			if (bFinish) {
				super.onBackPressed(); // 없으면 종료
			} else {
				Handler mHandler = new Handler() {
					@SuppressWarnings("deprecation")
					@Override
					public void handleMessage(Message msg) {
						if (bFinish) {
							bFinish = false;
						}
					}
				};
				mHandler.sendEmptyMessageDelayed(0, 3000);
				Toast.makeText(main, "\'이전\' 버튼을 한번 더 누르면 종료됩니다.",
						Toast.LENGTH_LONG).show();
				bFinish = true;
			}
		} else if (web.canGoBack()) {
			web.goBack();
		}
	}
}
